
with Interfaces.C;                      use Interfaces.C;
with Interfaces.C.Strings;              use Interfaces.C.Strings;

package body Allegro.Configuration is

    function Get_Config_Id( section, name : String; def : Integer ) return Integer is

        function C_Get_Config_Id( section, name : C.char_array; def : Integer ) return Integer;
        pragma Import( C, C_Get_Config_Id, "get_config_id" );

    begin
        return C_Get_Config_Id( To_C( section ), To_C( name ), def );
    end Get_Config_Id;

    ----------------------------------------------------------------------------

    function Get_Config_Float( section, name : String; def : Float ) return Float is

        function C_Get_Config_Float( section, name : C.char_array; def : Float ) return Float;
        pragma Import( C, C_Get_Config_Float, "get_config_float" );

    begin
        return C_Get_Config_Float( To_C( section ), To_C( name ), def );
    end Get_Config_Float;

    ----------------------------------------------------------------------------

    function Get_Config_Hex( section, name : String; def : Integer ) return Integer is

        function C_Get_Config_Hex( section, name : C.char_array; def : Integer ) return Integer;
        pragma Import( C, C_Get_Config_Hex, "get_config_hex" );

    begin
        return C_Get_Config_Hex( To_C( section ), To_C( name ), def );
    end Get_Config_Hex;

    ----------------------------------------------------------------------------

    function Get_Config_Int( section, name : String; def : Integer ) return Integer is

        function C_Get_Config_Int( section, name : C.char_array; def : Integer ) return Integer;
        pragma Import( C, C_Get_Config_Int, "get_config_int" );

    begin
        return C_Get_Config_Int( To_C( section ), To_C( name ), def );
    end Get_Config_Int;

    ----------------------------------------------------------------------------

    function Get_Config_String( section, name, def : String ) return String is

        function C_Get_Config_String( section, name, def : C.char_array ) return C.Strings.chars_ptr;
        pragma Import( C, C_Get_Config_String, "get_config_string" );

    begin
        return To_Ada( Value( C_Get_Config_String( To_C( section ),
                                                   To_C( name ),
                                                   To_C( def ) ) ) );
    end Get_Config_String;

    ----------------------------------------------------------------------------

    function Get_Config_Text( msg : String ) return String is

        function C_Get_Config_Text( msg : C.char_array ) return C.Strings.chars_ptr;
        pragma Import( C, C_Get_Config_Text, "get_config_text" );

    begin
        return To_Ada( Value( C_Get_Config_Text( To_C( msg ) ) ) );
    end Get_Config_Text;

    ----------------------------------------------------------------------------

    procedure Override_Config_Data( data : String ) is

        procedure C_Override_Config_Data( data : C.char_array; length : Integer );
        pragma Import( C, C_Override_Config_Data, "override_config_data" );

        c_data : constant C.char_array := To_C( data, Append_Nul => False );
    begin
        C_Override_Config_Data( c_data, c_data'Length );
    end Override_Config_Data;

    ----------------------------------------------------------------------------

    procedure Override_Config_File( filename : String ) is

        procedure C_Override_Config_File( filename : C.char_array );
        pragma Import( C, C_Override_Config_File, "override_config_file" );

    begin
        C_Override_Config_File( To_C( filename ) );
    end Override_Config_File;

    ----------------------------------------------------------------------------

    procedure Reload_Config_Texts( new_language : String ) is

        procedure C_Reload_Config_Texts( new_language : C.char_array );
        pragma Import( C, C_Reload_Config_Texts, "reload_config_texts" );

    begin
        C_Reload_Config_Texts( To_C( new_language ) );
    end Reload_Config_Texts;

    ----------------------------------------------------------------------------

    procedure Set_Config_Data( data : String ) is

        procedure C_Set_Config_Data( data : C.char_array; length : Integer );
        pragma Import( C, C_Set_Config_Data, "set_config_data" );

        c_data : constant C.char_array := To_C( data, Append_Nul => False );
    begin
        C_Set_Config_Data( c_data, c_data'Length );
    end Set_Config_Data;

    ----------------------------------------------------------------------------

    procedure Set_Config_File( filename : String ) is

        procedure C_Set_Config_File( filename : C.char_array );
        pragma Import( C, C_Set_Config_File, "set_config_file" );

    begin
        C_Set_Config_File( To_C( filename ) );
    end Set_Config_File;

    ----------------------------------------------------------------------------

    procedure Set_Config_Float( section, name : String; val : Float ) is

        procedure C_Set_Config_Float( section, name : C.char_array; val : Float );
        pragma Import( C, C_Set_Config_Float, "set_config_float" );

    begin
        C_Set_Config_Float( To_C( section ), To_C( name ), val );
    end Set_Config_Float;

    ----------------------------------------------------------------------------

    procedure Set_Config_Hex( section, name : String; val : Integer ) is

        procedure C_Set_Config_Hex( section, name : C.char_array; val : Integer );
        pragma Import( C, C_Set_Config_Hex, "set_config_hex" );

    begin
        C_Set_Config_Hex( To_C( section ), To_C( name ), val );
    end Set_Config_Hex;

    ----------------------------------------------------------------------------

    procedure Set_Config_Id( section, name : String; val : Integer ) is

        procedure C_Set_Config_Id( section, name : C.char_array; val : Integer );
        pragma Import( C, C_Set_Config_Id, "set_config_id" );

    begin
        C_Set_Config_Id( To_C( section ), To_C( name ), val );
    end Set_Config_Id;

    ----------------------------------------------------------------------------

    procedure Set_Config_Int( section, name : String; val : Integer ) is

        procedure C_Set_Config_Int( section, name : C.char_array; val : Integer );
        pragma Import( C, C_Set_Config_Int, "set_config_int" );

    begin
        C_Set_Config_Int( To_C( section ), To_C( name ), val );
    end Set_Config_Int;

    ----------------------------------------------------------------------------

    procedure Set_Config_String( section, name, val : String ) is

        procedure C_Set_Config_String( section, name, val : C.char_array );
        pragma Import( C, C_Set_Config_String, "set_config_string" );

    begin
        C_Set_Config_String( To_C( section ), To_C( name ), To_C( val ) );
    end Set_Config_String;

end Allegro.Configuration;
