
with Interfaces.C;                      use Interfaces.C;

package body Allegro.Fonts is

    procedure Destroy_Font( f : in out A_Font ) is

        procedure C_Destroy_Font( f : A_Font );
        pragma Import( C, C_Destroy_Font, "destroy_font" );

    begin
        C_Destroy_Font( f );
        f := null;
    end Destroy_Font;

    ----------------------------------------------------------------------------

    function Load_Bios_Font( filename : String; pal : A_RGB; param : Address ) return A_Font is

        function C_Load_Bios_Font( filename : C.char_array; pal : A_RGB; param : Address ) return A_Font;
        pragma Import( C, C_Load_Bios_Font, "load_bios_font" );

    begin
        return C_Load_Bios_Font( To_C( filename ), pal, param );
    end Load_Bios_Font;

    ----------------------------------------------------------------------------

    function Load_Bitmap_Font( filename : String; pal : A_RGB; param : Address ) return A_Font is

        function C_Load_Bitmap_Font( filename : C.char_array; pal : A_RGB; param : Address ) return A_Font;
        pragma Import( C, C_Load_Bitmap_Font, "load_bitmap_font" );

    begin
        return C_Load_Bitmap_Font( To_C( filename ), pal, param );
    end Load_Bitmap_Font;

    ----------------------------------------------------------------------------

    function Load_Dat_Font( filename : String; pal : A_RGB; param : Address ) return A_Font is

        function C_Load_Dat_Font( filename : C.char_array; pal : A_RGB; param : Address ) return A_Font;
        pragma Import( C, C_Load_Dat_Font, "load_dat_font" );

    begin
        return C_Load_Dat_Font( To_C( filename ), pal, param );
    end Load_Dat_Font;

    ----------------------------------------------------------------------------

    function Load_Font( filename : String; pal : A_RGB; param : Address ) return A_Font is

        function C_Load_Font( filename : C.char_array; pal : A_RGB; param : Address ) return A_Font;
        pragma Import( C, C_Load_Font, "load_font" );

    begin
        return C_Load_Font( To_C( filename ), pal, param );
    end Load_Font;

    ----------------------------------------------------------------------------

    function Load_Grx_Font( filename : String; pal : A_RGB; param : Address ) return A_Font is

        function C_Load_Grx_Font( filename : C.char_array; pal : A_RGB; param : Address ) return A_Font;
        pragma Import( C, C_Load_Grx_Font, "load_grx_font" );

    begin
        return C_Load_Grx_Font( To_C( filename ), pal, param );
    end Load_Grx_Font;

    ----------------------------------------------------------------------------

    function Load_Grx_Or_Bios_Font( filename : String; pal : A_RGB; param : Address ) return A_Font is

        function C_Load_Grx_Or_Bios_Font( filename : C.char_array; pal : A_RGB; param : Address ) return A_Font;
        pragma Import( C, C_Load_Grx_Or_Bios_Font, "load_grx_or_bios_font" );

    begin
        return C_Load_Grx_Or_Bios_Font( To_C( filename ), pal, param );
    end Load_Grx_Or_Bios_Font;

    ----------------------------------------------------------------------------

    function Load_Txt_Font( filename : String; pal : A_RGB; param : Address ) return A_Font is

        function C_Load_Txt_Font( filename : C.char_array; pal : A_RGB; param : Address ) return A_Font;
        pragma Import( C, C_Load_Txt_Font, "load_txt_font" );

    begin
        return C_Load_Txt_Font( To_C( filename ), pal, param );
    end Load_Txt_Font;

    ----------------------------------------------------------------------------

    procedure Register_Font_File_Type( ext : String; load : A_Font_Load_Callback ) is

        procedure C_Register_Font_File_Type( ext : C.char_array; load : A_Font_Load_Callback );
        pragma Import( C, C_Register_Font_File_Type, "register_font_file_type" );

    begin
        C_Register_Font_File_Type( To_C( ext ), load );
    end Register_Font_File_Type;

end Allegro.Fonts;
