
with Interfaces.C;                      use Interfaces.C;

package body Allegro.Image_Files is

    function Load_Bitmap( filename : String; pal : A_RGB ) return A_Bitmap is

        function C_Load_Bitmap( filename : C.char_array; pal : A_RGB ) return A_Bitmap;
        pragma Import( C, C_Load_Bitmap, "load_bitmap" );

    begin
        return C_Load_Bitmap( To_C( filename ), pal );
    end Load_Bitmap;

    ----------------------------------------------------------------------------

    function Load_BMP( filename : String; pal : A_RGB ) return A_Bitmap is

        function C_Load_BMP( filename : C.char_array; pal : A_RGB ) return A_Bitmap;
        pragma Import( C, C_Load_BMP, "load_bmp" );

    begin
        return C_Load_BMP( To_C( filename ), pal );
    end Load_BMP;

    ----------------------------------------------------------------------------

    function Load_LBM( filename : String; pal : A_RGB ) return A_Bitmap is

        function C_Load_LBM( filename : C.char_array; pal : A_RGB ) return A_Bitmap;
        pragma Import( C, C_Load_LBM, "load_lbm" );

    begin
        return C_Load_LBM( To_C( filename ), pal );
    end Load_LBM;

    ----------------------------------------------------------------------------

    function Load_PCX( filename : String; pal : A_RGB ) return A_Bitmap is

        function C_Load_PCX( filename : C.char_array; pal : A_RGB ) return A_Bitmap;
        pragma Import( C, C_Load_PCX, "load_pcx" );

    begin
        return C_Load_PCX( To_C( filename ), pal );
    end Load_PCX;

    ----------------------------------------------------------------------------

    function Load_TGA( filename : String; pal : A_RGB ) return A_Bitmap is

        function C_Load_TGA( filename : C.char_array; pal : A_RGB ) return A_Bitmap;
        pragma Import( C, C_Load_TGA, "load_tga" );

    begin
        return C_Load_TGA( To_C( filename ), pal );
    end Load_TGA;

    ----------------------------------------------------------------------------

    procedure Register_Bitmap_File_Type( ext  : String;
                                         load : A_Bitmap_Loader;
                                         save : A_Bitmap_Saver ) is

        procedure C_Register_Bitmap_File_Type( ext  : C.char_array;
                                               load : A_Bitmap_Loader;
                                               save : A_Bitmap_Saver );
        pragma Import( C, C_Register_Bitmap_File_Type, "register_bitmap_file_type" );

    begin
        C_Register_Bitmap_File_Type( To_C( ext ), load, save );
    end Register_Bitmap_File_Type;

    ----------------------------------------------------------------------------

    function Save_Bitmap( filename : String; bmp : A_Bitmap; pal : A_RGB ) return Boolean is

        function C_Save_Bitmap( filename : C.char_array; bmp : A_Bitmap; pal : A_RGB ) return Integer;
        pragma Import( C, C_Save_Bitmap, "save_bitmap" );

    begin
        return C_Save_Bitmap( To_C( filename ), bmp, pal ) = 0;
    end Save_Bitmap;

    ----------------------------------------------------------------------------

    function Save_BMP( filename : String; bmp : A_Bitmap; pal : A_RGB ) return Boolean is

        function C_Save_BMP( filename : C.char_array; bmp : A_Bitmap; pal : A_RGB ) return Integer;
        pragma Import( C, C_Save_BMP, "save_bmp" );

    begin
        return C_Save_BMP( To_C( filename ), bmp, pal ) = 0;
    end Save_BMP;

    ----------------------------------------------------------------------------

    function Save_BMP_pf( f : A_Packfile; bmp : A_Bitmap; pal : A_RGB ) return Boolean is

        function C_Save_BMP_pf( f : A_Packfile; bmp : A_Bitmap; pal : A_RGB ) return Integer;
        pragma Import( C, C_Save_BMP_pf, "save_bmp_pf" );

    begin
        return C_Save_BMP_pf( f, bmp, pal ) = 0;
    end Save_BMP_pf;

    ----------------------------------------------------------------------------

    function Save_PCX( filename : String; bmp : A_Bitmap; pal : A_RGB ) return Boolean is

        function C_Save_PCX( filename : C.char_array; bmp : A_Bitmap; pal : A_RGB ) return Integer;
        pragma Import( C, C_Save_PCX, "save_pcx" );

    begin
        return C_Save_PCX( To_C( filename ), bmp, pal ) = 0;
    end Save_PCX;

    ----------------------------------------------------------------------------

    function Save_PCX_pf( f : A_Packfile; bmp : A_Bitmap; pal : A_RGB ) return Boolean is

        function C_Save_PCX_pf( f : A_Packfile; bmp : A_Bitmap; pal : A_RGB ) return Integer;
        pragma Import( C, C_Save_PCX_pf, "save_pcx_pf" );

    begin
        return C_Save_PCX_pf( f, bmp, pal ) = 0;
    end Save_PCX_pf;

    ----------------------------------------------------------------------------

    function Save_TGA( filename : String; bmp : A_Bitmap; pal : A_RGB ) return Boolean is

        function C_Save_TGA( filename : C.char_array; bmp : A_Bitmap; pal : A_RGB ) return Integer;
        pragma Import( C, C_Save_TGA, "save_tga" );

    begin
        return C_Save_TGA( To_C( filename ), bmp, pal ) = 0;
    end Save_TGA;

    ----------------------------------------------------------------------------

    function Save_TGA_pf( f : A_Packfile; bmp : A_Bitmap; pal : A_RGB ) return Boolean is

        function C_Save_TGA_pf( f : A_Packfile; bmp : A_Bitmap; pal : A_RGB ) return Integer;
        pragma Import( C, C_Save_TGA_pf, "save_tga_pf" );

    begin
        return C_Save_TGA_pf( f, bmp, pal ) = 0;
    end Save_TGA_pf;

end Allegro.Image_Files;
