
with Ada.Strings.Hash_Case_Insensitive;

package body Actions is

    not overriding
    procedure Construct( this   : access Action;
                         id     : Action_Id;
                         source : not null access Widgets.Widget'Class ) is
    begin
        Object(this.all).Construct;
        this.id := id;
        this.source := source;
    end Construct;

    ----------------------------------------------------------------------------

    function Get_Id( this : not null access Action'Class ) return Action_Id is
    begin
        return this.id;
    end Get_Id;

    ----------------------------------------------------------------------------

    function Get_Source( this : not null access Action'Class ) return access Widgets.Widget'Class is
    begin
        return this.source;
    end Get_Source;

    ----------------------------------------------------------------------------

    overriding
    function "="( l, r : Action_Id ) return Boolean is
    begin
        return Hash_Type(l) = Hash_Type(r);
    end "=";

    ----------------------------------------------------------------------------

    function To_Action_Id( actName : String ) return Action_Id is
    begin
        return Action_Id(Ada.Strings.Hash_Case_Insensitive( actName ));
    end To_Action_Id;

end Actions;
