
with Events;

pragma Elaborate_All( Events );

package Events.Application is

    type Close_Window_Event is new Event with private;

    type App_Blur_Event is new Event with private;

    type App_Focus_Event is new Event with private;

    APP_BLUR_ID      : constant Event_Id := To_Event_Id( "App_Blur" );
    APP_FOCUS_ID     : constant Event_Id := To_Event_Id( "App_Focus" );
    CLOSE_REQUEST_ID : constant Event_Id := To_Event_Id( "Close_Request" );
    CLOSE_WINDOW_ID  : constant Event_Id := To_Event_Id( "Close_Window" );

    ----------------------------------------------------------------------------

    procedure Queue_App_Blur;

    procedure Queue_App_Focus;

    procedure Queue_Close_Request;

    procedure Queue_Close_Window;

private

    type App_Blur_Event is new Event with null record;

    procedure Construct( this : access App_Blur_Event );

    ----------------------------------------------------------------------------

    type App_Focus_Event is new Event with null record;

    procedure Construct( this : access App_Focus_Event );

    ----------------------------------------------------------------------------

    type Close_Request_Event is new Event with null record;

    procedure Construct( this : access Close_Request_Event );

    ----------------------------------------------------------------------------

    type Close_Window_Event is new Event with null record;

    procedure Construct( this : access Close_Window_Event );

end Events.Application;
