
package Game_Views.Window_Hooks is

    -- Register window behavior hooks with Allegro.
    procedure Initialize;

    -- Unregister the hooks.
    procedure Finalize;

    -- Returns True on the first call after the close window button has been
    -- clicked. For OS X this can also mean pressing Apple + Q or selecting Quit
    -- in the application's menu.
    function Close_Window_Clicked return Boolean;

private

    -- Called when the close button on the application window is clicked.
    procedure Close_Window_Callback;
    pragma Convention( C, Close_Window_Callback );

    -- Called when the application window regains focus.
    procedure Switch_In_Callback;
    pragma Convention( C, Switch_In_Callback );

    -- Called when the application window loses focus.
    procedure Switch_Out_Callback;
    pragma Convention( C, Switch_Out_Callback );

end Game_Views.Window_Hooks;
