
package body Keyboard is

    overriding
    function "="( l, r : Modifiers_Array ) return Boolean is
    begin
        return l(ALT)   = r(ALT) and then
               l(CTRL)  = r(CTRL) and then
               l(SHIFT) = r(SHIFT);
    end "=";
    pragma Inline( "=" );

    ----------------------------------------------------------------------------

    function None( mods : Modifiers_Array ) return Boolean is
    begin
        return not mods(ALT) and then not mods(CTRL) and then not mods(SHIFT);
    end None;
    pragma Inline( None );

    ----------------------------------------------------------------------------

    function Only_Alt( mods : Modifiers_Array ) return Boolean is
    begin
        return mods(ALT) and then not mods(CTRL) and then not mods(SHIFT);
    end Only_Alt;
    pragma Inline( Only_Alt );

    ----------------------------------------------------------------------------

    function Only_Ctrl( mods : Modifiers_Array ) return Boolean is
    begin
        return not mods(ALT) and then mods(CTRL) and then not mods(SHIFT);
    end Only_Ctrl;
    pragma Inline( Only_Ctrl );

    ----------------------------------------------------------------------------

    function Only_Shift( mods : Modifiers_Array ) return Boolean is
    begin
        return not mods(ALT) and then not mods(CTRL) and then mods(SHIFT);
    end Only_Shift;
    pragma Inline( Only_Shift );

    --==========================================================================

    function "="( l : Boolean; r : Trillian ) return Boolean is
    begin
        return r = Either or else
               (l and then r = Yes) or else
               (not l and then r = No);
    end "=";
    pragma Inline( "=" );

    ----------------------------------------------------------------------------

    function "="( l : Trillian; r : Boolean ) return Boolean is
    begin
        return l = Either or else
               (l = Yes and then r) or else
               (l = No and then not r);
    end "=";
    pragma Inline( "=" );

    --==========================================================================

    function "="( l : Modifiers_Array; r : Modifiers_Pattern ) return Boolean is
    begin
        for i in l'Range loop
            if l(i) /= r(i) then
                return False;
            end if;
        end loop;
        return True;
    end "=";
    pragma Inline( "=" );

    ----------------------------------------------------------------------------

    function "="( l : Modifiers_Pattern; r : Modifiers_Array ) return Boolean is
    begin
        for i in l'Range loop
            if l(i) /= r(i) then
                return False;
            end if;
        end loop;
        return True;
    end "=";
    pragma Inline( "=" );

end Keyboard;
