
; This script requires the Inno Setup Preprocessor add-on for Inno Setup

#define appName="Commander Keen 7"
#define versionShort=GetFileProductVersion( "bin\keen.exe" )
#define versionFull=GetFileVersion( "bin\keen.exe" )

[Setup]
; NOTE: The value of AppId uniquely identifies this application.
; Do not use the same AppId value in installers for other applications.
; (To generate a new GUID, click Tools | Generate GUID inside the IDE.)
AppId={{0CC3827E-83C2-409A-821D-6F1C2A8FE22E}
AppName={#appName}
AppVerName={#appName} {#versionShort}
AppPublisher=Kevin Wellwood
AppPublisherURL=http://wellwood.homeip.net:8000
AppSupportURL=http://wellwood.homeip.net:8000
AppUpdatesURL=http://wellwood.homeip.net:8000
DefaultDirName={pf32}\{#appName}
DisableDirPage=yes
DefaultGroupName={#appName}
DisableProgramGroupPage=yes
OutputDir=dist
OutputBaseFilename=keen-{#versionFull}-installer
Compression=lzma
SolidCompression=yes
UninstallDisplayIcon={app}\keen.exe
VersionInfoDescription={#appName} Installer
VersionInfoProductName={#appName} Installer
VersionInfoVersion={#versionFull}
SetupIconFile=keen\res\win\thumbsup.ico
WizardSmallImageFile=keen\res\win\installer-small.bmp
WizardImageBackColor=$FFFFFF
WizardImageFile=keen\res\win\installer-left.bmp

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"

[Tasks]
Name: "desktopicon"; Description: "{cm:CreateDesktopIcon}"; GroupDescription: "{cm:AdditionalIcons}"; Flags: unchecked

[Files]
Source: "bin\keen.exe"; DestDir: "{app}"; Flags: ignoreversion
Source: "bin\ked.exe"; DestDir: "{app}"; Flags: ignoreversion
Source: "bin\gfxpack.exe"; DestDir: "{app}"; Flags: ignoreversion
Source: "bin\alleg44.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "bin\files.digest"; DestDir: "{app}"; Flags: ignoreversion
Source: "bin\media\audio.zip"; DestDir: "{app}\media"; Flags: ignoreversion
Source: "bin\media\graphics.zip"; DestDir: "{app}\media"; Flags: ignoreversion
Source: "bin\media\resources.zip"; DestDir: "{app}\media"; Flags: ignoreversion
Source: "bin\media\worlds.zip"; DestDir: "{app}\media"; Flags: ignoreversion
; NOTE: Don't use "Flags: ignoreversion" on any shared system files

[Icons]
Name: "{group}\{#appName}"; Filename: "{app}\keen.exe"
Name: "{group}\Keen World Editor"; Filename: "{app}\ked.exe"
Name: "{group}\{cm:UninstallProgram,{#appName}}"; Filename: "{uninstallexe}"
Name: "{commondesktop}\{#appName}"; Filename: "{app}\keen.exe"; Tasks: desktopicon

[Run]
Filename: "{app}\keen.exe"; Description: "{cm:LaunchProgram,{#appName}}"; Flags: nowait postinstall skipifsilent

