
with Applications;
--with Debugging;                         use Debugging;
with Preferences;                       use Preferences;
with Support.Paths;                     use Support.Paths;

pragma Elaborate_All( Applications );
pragma Elaborate_All( Preferences );
pragma Elaborate_All( Support.Paths );

package body Applications.Keen is

    function Create_Application return A_Application is
        this : constant A_Application := new Keen_Application;
    begin
        this.Construct;
        return this;
    end Create_Application;

    ----------------------------------------------------------------------------

    overriding
    procedure Construct( this : access Keen_Application ) is
    begin
        Application(this.all).Construct( company  => "Kevin Wellwood",
                                         name     => "keen7",
                                         winTitle => "Commander Keen" );
        this.graphical := True;
        this.interactive := True;
        this.use_mouse := True;
        Set_Working_Directory;
    end Construct;

    ----------------------------------------------------------------------------

    overriding
    function Init( this : access Keen_Application ) return Boolean is
    begin
        return this.Init( 320, 200, app_scale => 2, app_windowed => True );
    end Init;

begin

    Register_Allocator( Create_Application'Access );

    Preferences.Set_Default( "application", "max_input_fps", 80 );
    Preferences.Set_Default( "application", "max_logic_fps", 120 );
    Preferences.Set_Default( "application", "max_render_fps", 60 );
    Preferences.Set_Default( "application", "media", "media" & Slash );
    Preferences.Set_Default( "application", "editing_mode", False );

end Applications.Keen;
