
package body Scale_X is

    procedure Scale2x( dst     : Address;
                       dstXres : Unsigned_32;
                       src     : Address;
                       srcXres : Unsigned_32;
                       width,
                       height  : Positive ) is
        procedure Scale2x_C( dst     : Address;
                             dstBpL  : Unsigned_32;
                             src     : Address;
                             srcBpL  : Unsigned_32;
                             pixel   : Unsigned_32;
                             width,
                             height  : Integer;
                             opt_tes : Integer );
        pragma Import( C, Scale2x_C, "scale2x" );
    begin
        Scale2x_C( dst, dstXres * 4, src, srcXres * 4, 4, width, height, 0 );
    end Scale2x;

    ----------------------------------------------------------------------------

    procedure Scale3x( dst     : Address;
                       dstXres : Unsigned_32;
                       src     : Address;
                       srcXres : Unsigned_32;
                       width,
                       height  : Positive ) is
        procedure Scale3x_C( dst     : Address;
                             dstBpL  : Unsigned_32;
                             src     : Address;
                             srcBpL  : Unsigned_32;
                             pixel   : Unsigned_32;
                             width,
                             height  : Integer;
                            opt_tes : Integer );
        pragma Import( C, Scale3x_C, "scale3x" );
    begin
        Scale3x_C( dst, dstXres * 4, src, srcXres * 4, 4, width, height, 0 );
    end Scale3x;

    ----------------------------------------------------------------------------

    function Scale4x( dst     : Address;
                      dstXres : Unsigned_32;
                      src     : Address;
                      srcXres : Unsigned_32;
                      width,
                      height  : Positive ) return Boolean is
        function Scale4x_C( dst     : Address;
                            dstBpL  : Unsigned_32;
                            src     : Address;
                            srcBpL  : Unsigned_32;
                            pixel   : Unsigned_32;
                            width,
                            height  : Integer;
                            opt_tes : Integer ) return Integer;
        pragma Import( C, Scale4x_C, "scale4x" );
    begin
        return Scale4x_C( dst, dstXres * 4, src, srcXres * 4, 4, width, height, 0 ) = 0;
    end Scale4x;

    ----------------------------------------------------------------------------

    procedure Scale2x3( dst     : Address;
                        dstXres : Unsigned_32;
                        src     : Address;
                        srcXres : Unsigned_32;
                        width,
                        height  : Positive ) is
        procedure Scale2x3_C( dst     : Address;
                              dstBpL  : Unsigned_32;
                              src     : Address;
                              srcBpL  : Unsigned_32;
                              pixel   : Unsigned_32;
                              width,
                              height  : Integer;
                              opt_tes : Integer );
        pragma Import( C, Scale2x3_C, "scale2x3" );
    begin
        Scale2x3_C( dst, dstXres * 4, src, srcXres * 4, 4, width, height, 0 );
    end Scale2x3;

    ----------------------------------------------------------------------------

    procedure Scale2x4( dst     : Address;
                        dstXres : Unsigned_32;
                        src     : Address;
                        srcXres : Unsigned_32;
                        width,
                        height  : Positive ) is
        procedure Scale2x4_C( dst     : Address;
                              dstBpL  : Unsigned_32;
                              src     : Address;
                              srcBpL  : Unsigned_32;
                              pixel   : Unsigned_32;
                              width,
                              height  : Integer;
                              opt_tes : Integer );
        pragma Import( C, Scale2x4_C, "scale2x4" );
    begin
        Scale2x4_C( dst, dstXres * 4, src, srcXres * 4, 4, width, height, 0 );
    end Scale2x4;

end Scale_X;
